# Use this for executing SQL commands after the initial schema has been created.

#PFS-1979 & PFS-2338
create index IDX_AP_ELM on Account_permissions (element varchar_pattern_ops);
create index IDX_GP_ELM on AGroup_permissions (element varchar_pattern_ops);

# PFS-3284
create index IDX_AE_ELM on Account_emails (element varchar_pattern_ops);

# PFS-2199
create index FK8D0FC952CB263F2E on Account_permissions (Account_oid);
create index FK636E2C83FFC2F9D1 on AGroup_permissions (AGroup_oid);
create index FK1D0C220DBDE4EB54 on Account (lastLoginFrom_id);
create index FK1D0C220DEA56CCFB on Account (defaultSyncFolder_id);
create index FK1D0C220DC5232D49 on Account (serverInfo_id);
create index FKF90034E69729BC92 on Account_Computers (id);
create index FKF90034E697826440 on Account_Computers (oid);
create index FKACEBA866FFC2F9D1 on Account_Groups (AGroup_oid);
create index FKACEBA866CB263F2E on Account_Groups (Account_oid);
create index FKDFD00AC9CB263F2E on Account_emails (Account_oid);
create index FK3D20982ACB263F2E on Account_licenseKeyFileList (Account_oid);
create index FKF989680C97826440 on Account_tokens (oid);
create index FKF989680C117FB197 on Account_tokens (serviceInfo_id);
create index FKD7FF5FB686608969 on FileLink (folderInfo_id);
create index FK568CBAD1C5232D49 on FolderSettings (serverInfo_id);
create index FK568CBAD186608969 on FolderSettings (folderInfo_id);
create index FKAC85A9431186FF48 on Organization_domains (Organization_oid);
create index FK9F78AB14CC189E9 on ServerInfo (memberInfo_id);
create index FKD9891A76D7CD4181 on Session (nodeInfo_id);
create index FK4D3C9D9D7CD4181 on Token (nodeInfo_id);
create index FK4D3C9D9117FB197 on Token (serviceInfo_id);
create index FKBE1153B9D7CD4181 on Invitation (nodeInfo_id);
create index FKBE1153B9117FB197 on Invitation (serviceInfo_id);

#PFS-2338
create unique index IDX_AP_UN on Account_permissions (Account_oid, element);
create unique index IDX_AC_UN on Account_computers (oid, id);
create unique index IDX_GP_UN on AGroup_permissions (AGroup_oid, element);

#PFS-2392
ALTER TABLE AGroup_permissions ADD CONSTRAINT PK_AGroup_permissions PRIMARY KEY (AGroup_oid, element);
ALTER TABLE Account_permissions ADD CONSTRAINT PK_Account_permissions PRIMARY KEY (Account_oid, element);
ALTER TABLE Account_Computers ADD CONSTRAINT PK_Account_Computers PRIMARY KEY (oid, id);
ALTER TABLE Account_Groups ADD CONSTRAINT PK_Account_Groups PRIMARY KEY (Account_oid, AGroup_oid);